diff -uwrN sourceold/scripts/jmgUtility.h source/scripts/jmgUtility.h
--- sourceold/scripts/jmgUtility.h	2016-12-17 21:07:23.267015700 +1000
+++ source/scripts/jmgUtility.h	2017-01-22 19:51:59.213626000 +1000
@@ -1098,6 +1098,17 @@
 		}
 		return NotDefined;
 	}
+	Priority Get_Objective_Priority(int objectiveId)
+	{
+		ObjectiveNode *current = objectiveNodeList;
+		while (current)
+		{
+			if (current->id == objectiveId)
+				return current->priority;
+			current = current->next;
+		}
+		return Undefined;
+	}
 	int Get_Objective_Status_Count(Status status,Priority requiredPriority = Undefined)
 	{
 		int count = 0;
@@ -1361,7 +1372,7 @@
 * \RespawnTime - Time it takes between spawns after last object was killed
 * \RespawnTimeRandom - Random time to add or subtract from the spawn time
 * \StartsEnabled - Can the object spawn on script create
-* \EnableCustom - Message used to enable the spawner, the parameter sent with it tell whether to enable or disable (1 for enable, 0 for disable, -1 disables and kills the spawned object, -2 disables and destroys the spawned object)
+* \EnableOrDisableCustom - Message used to enable the spawner, the parameter sent with it tell whether to enable or disable (1 for enable, 0 for disable, -1 disables and kills the spawned object, -2 disables and destroys the spawned object)
 * \SpawnLimit - How many objects can this script spawn
 * \DelayOnStartup - Day to spawn the first object when enabled
 * \author jgray
@@ -1444,6 +1455,7 @@
 * \DisableEngineOnArrival - Tells the unit whether it should shutdown its engine when it finishes moving, useful for wheeled vehicles so they don't go rolling away.
 * \WeaponError - This tells the max weapon error the vehicle can use, if weapon error is -1 it dynamically determines a weapon error to use, this calculation has to do with bullet speed and enemy distance.
 * \MaxHuntRange - This variable makes it so the AI can't see anything that is further than x meters from the wander point (or home position) it is currently moving too, if 0 this setting is ignored.
+* \NextWanderPointWhenLastReached - When 0 MinRandWander and MaxRandWander are used, when greater than 0 this is the distance the Vehicle must get to a wander point before choosing its next one
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -1483,6 +1495,7 @@
 	bool drivingBackward;
 	float maxHuntRangeSquared;
 	Vector3 lastWanderPointSpot;
+	float grabNextPointDistance;
 	void Created(GameObject *obj);
 	void Action_Complete(GameObject *obj,int action,ActionCompleteReason reason);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
@@ -1800,6 +1813,7 @@
 class JMG_Utility_Display_HUD_Info_Text_All_Players_Custom_Replace_String : public ScriptImpClass {
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
 };
+
 /*!
 * \brief Displays a hud message to all players on custom, allows user to override string with custom string
 * \Custom - Custom message to trigger the script on
@@ -2380,6 +2394,7 @@
 * \ReactToAttackRate - Rate at which the AI will recalculate whether or not it'll acknowledge attack damage
 * \ShutdownEngineOnArrival - used for vehicles to shut off their engines when they arrive at the point
 * \EnableDebug - If true the bot will print out any points it cannot get to WARNING: this will print off both when the bot can't reach it due to the point being in a bad spot AND the bot being in a bad spot
+* \UseSecondaryFire - Should secondary fire be used when attacking
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -2423,6 +2438,7 @@
 	bool reactToAttackChance;
 	Vector3 lastPosition;
 	bool moveBackward;
+	bool usePrimaryFire;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *seen);
 	void Timer_Expired(GameObject *obj,int number);
@@ -2659,6 +2675,7 @@
 * \PrimaryObjectiveModel - Visible 3d model to show for Primary Objectives
 * \SecondaryObjectiveModel - Visible 3d model to show for Secondary Objectives
 * \TertiaryObjectiveModel - Visible 3d model to show for Tertiary Objectives
+* \Team - Team to show the objectives for
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -3169,6 +3186,7 @@
 * \Param - Param to send
 * \Delay - Delay to add before sending custom
 * \TriggerOnce - Allows the script only to trigger the first time the zone is entered
+* \RemoveWeapon - Removes the weapon from the player if true
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -3394,6 +3412,7 @@
 * \MessageColor - Color to display the chat message in
 * \LineDelayTime - Delay between each message displayed
 * \UISound - 2D sound to play when custom received
+* \Repeatable - Allows the script to trigger more than once
 * \File Format Example
 [Tag]
 Text typed here will be displayed for this tag when the custom is received, the line can be up to 16384 characters long.
@@ -3429,6 +3448,7 @@
 	};
 	BriefingTextNode *BriefingText;
 	BriefingTextNode *CurrentNode;
+	bool triggered;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
@@ -3923,6 +3943,7 @@
 {
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void Destroyed(GameObject *obj);
 public:
 	static int deathCount;
 	static int maxDeaths;
@@ -3937,6 +3958,7 @@
 	static char remainingSingular[220];
 	static char remainingPlural[220];
 	static int reminderMessageOrder;
+	static bool controllerPlaced;
 };
 
 /*!
@@ -4359,7 +4381,7 @@
 * \EndID - ID to stop at
 * \PlayerCount[eq|<|>] - Set the player count for the conditions to enable the spawners, enter -1 ignores the condition (equal, less than, greater than)
 * \PlayerCount[neq|between(|)] - Set the player count for the conditions to enable the spawners, enter -1 ignores the condition (not equal, between)
-* \EnableCustom - Custom pauses the script or unpauses it, param enables/disables (spawner current state is left enabled/disabled)
+* \EnableOrDisableCustom - Custom pauses the script or unpauses it, param enables/disables (spawner current state is left enabled/disabled)
 * \StartsEnabled - Should this script be running on map load
 * \author jgray
 * \ingroup JmgUtility
@@ -4390,7 +4412,7 @@
 * \WeaponName - Name of the weapon to grant to the player
 * \Location - Location to grant the weapon at
 * \Range - Range from the location to grant the weapon
-* \EnableCustom - Custom to enable the scanning, parameter determines if its enabled or disabled 1 = enabled, 0 = disabled
+* \EnableOrDisableCustom - Custom to enable the scanning, parameter determines if its enabled or disabled 1 = enabled, 0 = disabled
 * \StartsEnabled - Should to script start running 1 = true, 0 = false
 * \Rate - Speed at which to scan, 0.0 will disable the repeated scanning and then only enable custom will trigger a scan
 * \SelectWeapon - Should the player pull out the weapon when its granted
@@ -4454,21 +4476,28 @@
 * \MessageFollowingPlayerID - Message to display to the player if they poke a bot that is following someone else
 * \MessageMaxFollowersID - Message to display if the player attempts to have more followers than allowed (message is formatted: You can only have %d creature%sfollowing you.)
 * \MessageHealingRequiredID - Message to display when the follower is hurt and has to heal before following again, only available when FallBackWhenOutOfArmor is on
-* \MessageFollowerLostID - Message to display when the player the follower is following wanders out of the pathfind zone
+* \MessageFollowerLostID - Message to display when the player the follower is following wanders out of the pathfind zone or if they follow the player for to long
 * \MessageFollowerInjuredID - Message to display when the follower runs out of armor, FallBackWhenOutOfArmor must be on
 * \MessageFollowerKilledID - Message to display when the follower dies following someone
 * \SendCustomID - ID of the object customs should be sent to
 * \PokedCustom - Custom to send when the follower is poked and starts following
-* \LostCustom - Message to send if the follower gets lost
+* \LostCustom - Message to send if the follower gets lost or if they follow the player for to long
 * \InjuredCustom - Message to send when the follower gets injured, requires FallBackWhenOutOfArmor be on
 * \KilledCustom - Message to send if the follower is killed 
 * \HealedCustom - Message to send when the follower gets to full health, requires FallBackWhenOutOfArmor be on
+* \MaxFollowTime - Amount of time the AI can follow the player before getting bored and running home (in 10ths of a second)
+* \MaxIdleTime - Max amount of time an AI can stand still while "following" a player before running home (in 10ths of a second)
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_AI_Follow_Player_On_Poke : public ScriptImpClass {
 	GameObject *lastFollow;
 	GameObject *lastTarget;
+	Vector3 lastPos;
+	int maxFollowTime;
+	int maxIdleTime;
+	int currentFollowTime;
+	int currentIdleTime;
 	bool detached;
 	float followDistance;
 	float followNearSpeed;
@@ -4561,7 +4590,7 @@
 };
 
 /*!
-* \brief Fades the screen and applies damage as the player gets further from the spot on the map, kills player if they wander outside a max range
+* \brief Fades the screen and applies damage as the player gets further from the spot on the map, kills player if they wander outside a max range, uses JMG_Utility_Set_Screen_Color_Fade_Controller for default screen colors
 * \Warn_Distance - Distance at which the warning message appears on the HUD for infantry
 * \Damage_Distance - Distance at which the infantry starts taking damage
 * \Vehicle_Warn_Distance - Distance at which the warning message appears on the HUD for vehicle
@@ -4585,10 +4614,508 @@
 	float maxSurviveDistance;
 	Vector3 errorMessageColor;
 	Vector3 screenFadeColor;
-	Vector3 myPos;
 	int warnTime[128];
 	bool screenEffectOn[128];
 	int leavingFieldStringId;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 };
\ No newline at end of file
+
+/*!
+* \brief Sends a custom message when no more objects of the preset name exist on the map, then removes itself
+* \PresetName - preset name to search for 
+* \StartsEnabled - If 0 it doesn't start scanning until enabled, otherwise starts scanning on attach
+* \EnableOrDisableCustom - Custom used to enable the script, a param of 0 disables the script again, anything besides 0 enables
+* \ID - Id of the object to send the custom to, 0 sends to itself
+* \Message - Custom to send
+* \Param - parameter to send with the custom
+* \Delay - Time amount to wait before sending the custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_When_No_More_Presets_Of_Type_Exist : public ScriptImpClass {
+	char presetName[128];
+	int enableCustom;
+	bool enabled;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Sends a custom message when a player goes beyond a certain range of this object
+* \Distance - how far away can the plaeyrs go
+* \ID - Id of the object to send the custom to, 0 sends to itself
+* \Message - Custom to send
+* \Param - parameter to send with the custom
+* \Delay - Time amount to wait before sending the custom
+* \TriggerOnce - If true the script can only fire once
+* \sleepTime - Value in 10ths of a second the script must wait before sending the custom again
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_When_Player_Outside_Of_Range : public ScriptImpClass {
+	int sleepTime;
+	int sleeping;
+	bool triggerOnce;
+	bool enabled;
+	float distance;
+	float delay;
+	int id;
+	int param;
+	int custom;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Sets the player type to -2 when no armor, sets player type back to the original player type when armor is full
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Set_Team_To_Neutral_When_No_Armor : public ScriptImpClass {
+	bool hurt;
+	int originalPlayerType;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Sends a custom message when no more objects on the specified team exist 
+* \Team - team that should be scanned for
+* \StartsEnabled - If 0 it doesn't start scanning until enabled, otherwise starts scanning on attach
+* \EnableOrDisableCustom - Custom used to enable the script, a param of 0 disables the script again, anything besides 0 enables
+* \ID - Id of the object to send the custom to, 0 sends to itself
+* \Message - Custom to send
+* \Param - parameter to send with the custom
+* \Delay - Time amount to wait before sending the custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist : public ScriptImpClass {
+	int team;
+	int enableCustom;
+	bool enabled;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Creates a 3D sound at the specified bone on custom
+* \Sound - Sound preset to play
+* \Bone - Bone to play the sound from
+* \Custom - Custom message to trigger the sound
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Create_Sound_At_Object_Bone : public ScriptImpClass {
+	char sound[128];
+	char bone[32];
+	int custom;
+	bool enabled;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom when a custom has been received x times with addition of a player count multiplier, script destroys itself after it triggers once
+* \Custom - Custom to count
+* \BaseCount - how many customs needed
+* \PlayerCount - added to the base count, multiplied by the number of players in game
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send
+* \Delay - delay to add
+* \ResetCustom - custom to reset the count
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_On_Player_Count : public ScriptImpClass {
+	int custom;
+	int resetCustom;
+	int baseCount;
+	int playerCount;
+	int runningCount;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom message when killed by a player
+* \ID - Id of the object to send the custom to, 0 sends to itself, -1 to killer
+* \Message - Custom to send
+* \Param - parameter to send with the custom
+* \Delay - Time amount to wait before sending the custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Killed_By_Player_Send_Custom : public ScriptImpClass {
+	void Killed(GameObject *obj,GameObject *killer);
+};
+
+/*!
+* \brief Makes this unit ignored by all the Guardian AI scripts
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_AI_Guardian_Ignored : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Makes this unit ignored by all JMG_Utility_AI_Vehicle
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_AI_Vehicle_Ignored : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Sends a custom message when killed by a specific PresetID
+* \PresetID - Preset ID to detect
+* \ID - Id of the object to send the custom to, 0 sends to itself, -1 to killer
+* \Message - Custom to send
+* \Param - parameter to send with the custom
+* \Delay - Time amount to wait before sending the custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Killed_By_PresetID_Send_Custom : public ScriptImpClass {
+	void Killed(GameObject *obj,GameObject *killer);
+};
+
+/*!
+* \brief Makes an AI able to shoot directions the gun isn't aiming
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Created_Override_AI_Soldier_Muzzle_Direction : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Sends a custom when a custom has been received x times with addition of a player count multiplier, script destroys itself after it triggers once, also displays the current count on the HUD
+* \Custom - Custom to count
+* \BaseCount - how many customs needed
+* \PlayerCount - added to the base count, multiplied by the number of players in game
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send
+* \Delay - delay to add
+* \ResetCustom - custom to reset the count
+* \HudStringId - stringId for the string to be parsed and displayed on the HUD, formatting goes %d/%d (current count out of calculated total)
+* \HudStringColor - RGB value for the HUD message (0.0-1.0)
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_On_Player_Count_HUD : public ScriptImpClass {
+	Vector3 hudStringColor;
+	char hudMessage[220];
+	int hudStringId;
+	int custom;
+	int resetCustom;
+	int baseCount;
+	int playerCount;
+	int runningCount;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	char *formatHUDMessage(const char *format,...);
+};
+
+/*!
+* \brief Sends a custom if the object entering the zone has a weapon, one custom is sent for each ammo count the weapon has
+* \PlayerType - Player type the zone triggers for
+* \WeaponName - Name of the weapon needed to trigger the zone
+* \ID - ID to send the custom to, 0 sends to self, -1 sends to enter
+* \Custom - Custom message to send
+* \Param - Param to send
+* \Delay - Delay to add before sending custom
+* \RemoveWeapon - Should the weapon be removed when entering the zone
+* \TriggerOnce - Allows the script only to trigger the first time the zone is entered
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Zone_Send_Custom_If_Has_Weapon_Ammo : public ScriptImpClass {
+	void Entered(GameObject *obj,GameObject *enterer);
+};
+
+/*!
+* \brief Removes a weapon from all the players in game when a custom is received
+* \Custom - Custom to count
+* \WeaponName - name of the weapon preset to remove
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Remove_Weapon_From_All_Players : public ScriptImpClass {
+	int custom;
+	char weaponName[128];
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Destroys all the objects on the map with matching preset name
+* \Custom - Custom to trigger the script
+* \PresetName - Name of the preset to hunt down and destroy
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Destroy_All_Presets_By_Name : public ScriptImpClass {
+	int custom;
+	char presetName[128];
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom when an object has been damaged over a specified amount, also can have a delay how often the custom can be sent again
+* \DamageThreshold - Amount of damage that must be done to trigger the script
+* \LockoutTime - Amount of time that must go by before the script can trigger again
+* \ID - ID to send the custom to, 0 sends to self, -1 sends to enter
+* \Custom - Custom message to send
+* \Param - Param to send
+* \Delay - Delay to add before sending custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_When_Damage_Exceedes_Threshold : public ScriptImpClass {
+	int id;
+	int custom;
+	int param;
+	float delay;
+	float damageThreshold;
+	float lockoutTime;
+	float timeRemaining;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Damaged(GameObject *obj,GameObject *damager,float damage);
+};
+
+/*!
+* \brief Sends a chat message to all players on custom
+* \Custom - Custom message to trigger the script on
+* \StringId - String ID to send through the chat console to all players
+* \ColorRGB - Color of the HUD message to display 0-255
+* \Repeatable - Can the script trigger more than once
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Translated_String_To_All_Players : public ScriptImpClass {
+	int custom;
+	Vector3 color;
+	int stringId;
+	bool repeatable;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Creates a powerup at the objects origin when it is destroyed if it has that weapon
+* \WeaponPreset - Weapon that is needed to do the drop
+* \PowerupName - Powerup to create
+* \HeightAdjust - Height to add to the object's origin to create the powerup at
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Destroyed_Drop_Powerup : public ScriptImpClass
+{
+	void Destroyed(GameObject *obj);
+};
+
+/*!
+* \brief Attaches a script to the soldier that picked up the powerup
+* \Script - Script to attach
+* \Params - Params to use
+* \Delim - char to use in place of ,
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Pickup_Attach_Script : public ScriptImpClass
+{
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Used to update the status of an objective
+* \Custom - Custom to trigger on
+* \ObjectiveID - ID of the new objective to update
+* \NewObjectiveStringID - Strings.tbl id for the objective message
+* \NewObjectiveMarkerObjectID - ID of the object where the marker should be displayed (-1 sets the sender as the marker)
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Objective_System_Objective_Status_Update_Custom : public ScriptImpClass {
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Used to make an objective show up as failed
+* \Custom - Custom to trigger this script
+* \ObjectiveID - ID of the new objective to remove
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Objective_System_Objective_Failed_Custom : public ScriptImpClass {
+	int custom;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Places all players on the same team at the end of the round
+* \Team - Team to force all players to
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Force_Player_Team_At_Gameover : public ScriptImpClass {
+	int team;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Makes a unit move between wander points, it'll strafe at the target while it has one, clone of JMG_Utility_AI_Guardian_Aircraft but with pathfind enabled
+* \WanderingAIGroupID - Group of points to wander between
+* \WanderSpeed - Speed the unit moves at 
+* \FireRange - Max range that it can use it's guns
+* \CheckBlocked - Whether to check if the target spot is blocked before firing
+* \ArriveDistance - Distance to get close to
+* \FlightHeight - How high should the aircraft fly (use 0 if not an aircraft)
+* \TurnOffEngineOnArrival - Should the vehicle kill its engine when it arrives
+* \UseSecondaryAttack - Should the unit attack with its secondary fire instead
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_AI_Guardian_Generic : public ScriptImpClass {
+	float flightHeight;
+	float arriveDistance;
+	float arriveDistanceSq;
+	Vector3 dpPosition;
+	int EnemyID;
+	int EnemyTimeOutTime;
+	Vector3 LastPos;
+	bool primaryFire;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Enemy_Seen(GameObject *obj,GameObject *seen);
+	void Damaged(GameObject *obj,GameObject *damager,float damage);
+	void Goto_Location(GameObject *obj);
+	bool Get_A_Defense_Point(Vector3 *position);
+};
+
+/*!
+* \brief Creates an object in front of this object
+* \Custom - Custom to trigger the script
+* \PresetName - Name of the preset to create
+* \Distance - Distance in front of the object to place the new object
+* \Height - Height to add to the new object
+* \Rotation - Rotation to add to the new object (base rotation is the same as the old object)
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Create_Object_In_Front_Of_Self : public ScriptImpClass {
+	int custom;
+	char presetName[128];
+	float distance;
+	float height;
+	float rotation;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Makes this unit ignored by JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist
+* \Ignore - Does nothing, just here so you can tell which script this is beings the name is cut off
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_When_No_More_Units_On_Team_Exist_Ignore : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Damages all vehicles on a team when a custom is received
+* \Custom - Custom to count
+* \Team - team to wipe out
+* \Damage - how much damage to apply
+* \Warhead - warhead to use
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Damage_All_Vehicles_On_Team : public ScriptImpClass {
+	int custom;
+	int team;
+	float damage;
+	char warhead[128];
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Kills a unit if it doesn't manage to move more than the specified distance in the specified time
+* \Time - amount of time the unit has to move
+* \Distance - the distance the unit has to move
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Kill_Unit_If_Not_Moving_Enough : public ScriptImpClass {
+	int time;
+	int resetTime;
+	float distance;
+	Vector3 lastPos;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+
+/*!
+* \brief Reads text from a file and displays it to the screen, 
+* \ the text in a file is broken every 150 characters (tries to end the current word) and then delayed by 6 seconds
+* \ Note: This will only work once because of how it works
+* \Custom - Custom to trigger this script on
+* \StringID - ID of the string from strings.tbl to parse and play out
+* \MessageColor - Color to display the chat message in
+* \LineDelayTime - Delay between each message displayed
+* \UISound - 2D sound to play when custom received
+* \Repeatable - Allows the script to trigger more than once
+* \Special Notes:
+-String max length is 16384 characters long
+-Line break/delay - Use this character ''(there is a character in there, you'll have to copy it out) to end the line, you can also use a bunch of them to add a delay to the message.
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Display_Briefing_Message_StringID : public ScriptImpClass {
+	struct BriefingTextNode
+	{
+		char Text[256];
+		float Delay;
+		BriefingTextNode *next;
+		BriefingTextNode(const char *text)
+		{
+			Delay = 0.0f;
+			sprintf(Text,"%s",text); 
+			next = NULL;
+		}
+		BriefingTextNode(const char *text,float delay)
+		{
+			Delay = delay;
+			sprintf(Text,"%s",text); 
+			next = NULL;
+		}
+		BriefingTextNode()
+		{
+			next = NULL;
+		}
+	};
+	BriefingTextNode *BriefingText;
+	BriefingTextNode *CurrentNode;
+	bool triggered;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void Destroyed(GameObject *obj);
+	void AddNewTextNode();
+	void RemoveTextNodes();
+};
\ No newline at end of file
